<template>
	<v-row v-if="messages.length != 0">
		<v-col cols="12" sm="3" md="4" v-for="message of messages" :key="message.id">
			<v-card>
				<v-toolbar dark color="#c51f2f" v-if="!message.done">
					<v-toolbar-title>De: Becas COZCyT</v-toolbar-title>
					<v-spacer></v-spacer>
					<v-toolbar-items>
						<v-btn icon @click="messageButton(message.id)">
							<v-icon>fas fa-check</v-icon>
						</v-btn>
					</v-toolbar-items>
				</v-toolbar>
				<v-toolbar dark color="success" v-else>
					<v-toolbar-title>De: Becas COZCyT</v-toolbar-title>
					<v-spacer></v-spacer>
					<v-toolbar-items>
						<v-btn icon @click="messageButton(message.id)">
							<v-icon>fas fa-times</v-icon>
						</v-btn>
					</v-toolbar-items>
				</v-toolbar>
				<v-card-text>
					<p class="body-1">{{message.sendDate}}</p>
					<p class="body-1">{{message.message}}</p>
				</v-card-text>
			</v-card>
		</v-col>
	</v-row>
	<v-row justify="center" v-else>
		<p class="headline">No tienes mensajes disponibles</p>
	</v-row>
</template>

<script>
import gql from "graphql-tag";
import EventBus from "../../bus";
import { mapState } from 'vuex';

export default {
	name: "Notification",
	data: () => ({
		messages: []
	}),
	computed:{
		...mapState(["userData"])
	},
	methods: {
		// Obtiene los mensajes
		async getMessages() {
			try {
				const { data } = await this.$apollo.query({
					query: gql`
						query($curp: String!) {
							getAllMessages(curp: $curp) {
								messages {
									id
									sendDate
									message
									done
								}
							}
						}
					`,
					variables:{
						curp: this.userData.curp
					}
				});
				this.messages = data.getAllMessages.messages;
				
				const meses = ["Enero", "Febrero", "Marzo", "Abril", "Mayo", "Junio", "Julio", "Agosto", "Septiembre", "Octubre", "Noviembre", "Diciembre"];
				this.messages = this.messages.map(messageData => {
					const id = messageData['id'];
					const message = messageData['message'];
					const done = messageData['done'];
					const date = messageData['sendDate'];
					let sendDate = new Date(parseInt(date));
					sendDate = `
						Fecha de recibido: ${sendDate.getDate()} 
						de ${meses[sendDate.getMonth()]} 
						del ${sendDate.getFullYear()} 
						a ${sendDate.getHours() === 1 ? "la" : "las"} 
						${sendDate.getHours()}:${(sendDate.getMinutes() < 10) ? `0${sendDate.getMinutes()}` :sendDate.getMinutes()}
					`;
					return { id, message, sendDate, done }
				})
			} catch (error) {}
		},
		// cambia el estado del mensaje
		async messageButton(id){
			try {
				await this.$apollo.mutate({
					mutation: gql`
						mutation($id: ID) {
							markMessageDone(
								id: $id
							)
						}
					`,
					variables: {
						id
					}
				});
				for(let i of this.messages){
					if(i.id === id){
						i.done = !i.done;
					}
				}
			} catch (error) { }
		},
	},
	created() {
		this.getMessages();
	}
};
</script>